Viewing Issue Advanced Details
ID Category [?] Severity [?] Reproducibility Date Submitted Last Update
07131 Graphics Minor Always Oct 28, 2018, 18:12 Dec 22, 2018, 14:59
Tester nippur72 View Status Public Platform
Assigned To Robbbert Resolution Fixed OS
Status [?] Resolved Driver vtech2.cpp
Version 0.202 Fixed in Version 0.205 Build
Summary MESS-specific 07131: laser500: charset ROM is wrong (and I fixed it)
Description the charset ROM for laser 350/500/700 referenced in MESS was originally drawn by hand and does contain many errors. For example the "D" and "m" have a different graphics than the real machine.

I've fixed such errors for a Laser 500 emulator of my own, but I cannot use in MAME/MESS because of the different CRC.

I enclose the fixed ROM file, but I don't know exactly how this will be handled since MAME/MESS does not ship rom files...
Steps To Reproduce
Additional Information
Flags
Regression Version
Affected Sets / Systems laser500
Attached Files
jpg file icon example.jpg (90,071 bytes) Oct 28, 2018, 18:14 Uploaded by nippur72
nippur72
zip file icon laser500.charset.rom.zip (1,906 bytes) Nov 3, 2018, 09:42 Uploaded by nippur72
charset ROM dumped by Tonino Bisazza, 02-nov-2018
jpg file icon P1000544.JPG (3,508,165 bytes) Dec 21, 2018, 16:26 Uploaded by nippur72
Snapshots of the schematic diagram - keyboard
Relationships
There are no relationship linked to this issue.
Notes
9
User avatar
No.15642
nippur72
Tester
Oct 28, 2018, 18:16
sorry, the submit form attach file function is bugged and caused #7129 and #7130 issues to be opened. They can be deleted.
User avatar
No.15661
hap
Developer
Oct 30, 2018, 09:08
Did you dump the rom chip, or did you correct the graphics manually by comparing to the real Laser 500?
If it was dumped, is the size correct? MAME's source says this rom is a TMS 2364-25NL (aka 8KB)
User avatar
No.15706
nippur72
Tester
Nov 2, 2018, 18:37
No I did not dump it, I just manually corrected the graphics comparing to the real machine.

Yes the ROM is an 8K, on the Laser 700 it's a "TMS 2364-25NL", on the Laser 500 it's an EPROM labeled "ZA234015".

Looking at the schematic diagram of the 500/700 it seems that not all pins are directly connected, only A0-A10 go straight to the video chip, A11 and A12 are driven in a strange way I don't understand.
User avatar
No.15712
Robbbert
Developer
Nov 3, 2018, 03:13
You can use it in MAME/MESS if you rename your file to the same as the original one, and then you run MAME from the command line.
User avatar
No.15714
nippur72
Tester
Nov 3, 2018, 09:57
UPDATE: I managed to get a real dump for the charset ROM. Tonino Bisazza extracted it yesterday from a working Laser 500.

I deleted the manually created file and substituted it with the the correct one named "laser500.charset.rom.zip".

Tonino Bisazza said he dumped the ROM as if it was 16K sized eprom, but only the topmost 8K contains data, suggesting it's actually an 8K eprom.

Previously unknown, the ROM contains ENGLISH, GERMAN and FRENCH charsets at different offsets that are enabled by hardware switches (presumably when they customized the machine for different countries along with the QZERTY keyboard layout). The circuit diagram shows two switches corresponding to A11 and A12 lines in the ROM.

Another difference from before is that the graphics in the ROM is flipped horizontally: the most significant bit is the rightmost pixel in a row, not leftmost.
User avatar
No.15905
Robbbert
Developer
Dec 13, 2018, 05:14
edited on: Dec 13, 2018, 05:17
I've tried this out in the laser500, seems ok.

Is it also used in the laser350 and 700?

Do you have a schematic of this computer? I've noticed various other things that aren't working.
User avatar
No.15938
nippur72
Tester
Dec 21, 2018, 16:44
@Robbbert yes it is the same in Laser 350, 500 and 700.

As for the schematic, Piero Andreini borrowed a copy of the manual and took some snapshots. I've uploaded the most interesting one for MAME, which is the keyboard schematic.

There are two things that needs to be fixed:
- keyboard rows A,B,C,D are incorrectly coded in MAME and some of the corresponding keys are not working, like cursor keys (I opened an issue about it).
- three separate machine configurations need to be created: ENGLISH (qwerty), FRENCH (azerty) and GERMAN (qwertz). When in FRENCH / GERMAN the bit corresponding to A5-KD5 in the schematic needs to be raised to 1 (A5-KD4 for GERMAN). Also the display driver should point to different offsets in the charset ROM in order to display the french/german character set.

Please let me know if you need other pages from the schematic (the whole file is too big to be uploaded).
User avatar
No.15939
Robbbert
Developer
Dec 21, 2018, 23:47
edited on: Dec 21, 2018, 23:48
Can you upload the entire thing (in 100MB chunks) to a file upload service such as mega.nz? I can get it converted to PDF.


New rom added to laser350/500/700.

At this stage the german/french variants are not coded in, to be looked at later.
User avatar
No.15941
Robbbert
Developer
Dec 22, 2018, 14:59
Language selection added.